# Contributing Guidelines

First of all, thank you very much for being interested in contributing to the search index application or one of the specific services (OERSI, ReSoDaTe, ...)! Contributions of any kind are welcome - for example proposing a new source for a specific service (like Open Educational Resources or Research Data), submitting a bug report, requesting a new feature, translating the application into a new language, or actively contributing to the source code.

If you want to contribute to the search index, please make sure to read through and follow these guidelines. The guidelines apply to all search index repositories.

If you need help or have any questions that are not covered by this guide, please contact us at contact-project+oersi-oersi-setup-support1@incoming.gitlab.com

## Table of Contents

[[_TOC_]]

## Submitting an Issue

Before creating a new issue, start by searching through the [issues](https://gitlab.com/groups/oersi/-/issues/?sort=updated_desc&state=all&first_page_size=100) and [open merge requests](https://gitlab.com/groups/oersi/-/merge_requests) to see whether someone else has raised a similar idea or question. If you don't see your idea listed, do one of the following:
* If your contribution is a minor change of the code, such as a typo fix, open a merge request.
* Otherwise open an issue first. That way, other people can weigh in on the discussion before you do any work.

### Propose a new source

We are interested in more sources for the specific services and welcome any suggestions. Please use the following templates:

* OERSI - Open Educational Resources (the higher education context): https://gitlab.com/oersi/oersi-etl/-/issues/new?issuable_template=add-source
* RESODATE - Research Software, Data and Terminologies: https://gitlab.com/TIBHannover/resodate/resodate-import-scripts/-/issues/new?issuable_template=add-source
* Course Catalogue - Common Course Catalogue of European Universities: https://gitlab.com/TIBHannover/course-catalogue/course-catalogue-import-scripts/-/issues/new?issuable_template=add-source
* ... (have a look in the group of specific service)

### Adding translation

We are happy to accept new languages for the search index frontend and labels in the data. Please use the following template: https://gitlab.com/oersi/sidre/sidre-frontend/-/issues/new?issuable_template=add-translation and see also [Add new language](https://oersi.gitlab.io/sidre/sidre-docs/howto/add-new-translation/)

### Bug Report

Bug reports include anything that causes the application to behave in an unintended way. Please describe the error as detailed as possible (where did the error occur, what happened, what are the consequences) and tell us what is your expected behavior in the case. Please also describe how the error can be reproduced.

### Change / Feature Request

Changes / Feature Request include any functional code that should be adjusted / added. This can include small adjustments or translations, but it can also include large adjustments. The change or new feature should be described in detail, as well as the problem that should be solved. What exactly needs to be changed / added and how the system should behave. It is also very important to specify the use case for the issue, so that it is clear why the issue should be implemented.

## Contributing to the source code

Please ensure that you comply with the license, coding conventions, definition of done and the workflow for submitting merge requests. 

Contributions to an issue are always developed in a feature branch. The feature-branch may only contain changes for one issue - contributions to different issues may not be mixed in one MR.

When you select tasks for development, you can either search the repository for existing issues to work on, or you can submit your own issues if you don't find any that cover the topic of your interest (see the [Submitting an Issue](#submitting-an-issue) section of this guide). Issues that you want to work on should first be marked with the label `approval requested` and then wait for one of the core developers to discuss and approve the development with you. Please do not start the implementation until it has been agreed with the search index team.

### Issue workflow

* The [Search Index Issue Board](https://gitlab.com/groups/oersi/-/boards) gives an overview of which issues are currently being worked on.
* Open issues may have to be evaluated and discussed by the search index core team first - especially issues with status `approval requested` or `specification`. If it is decided that an issue can be implemented, the label `Ready` is set by the search index core team.
* Issues with label `Ready` are ready for implementation - as soon as someone starts an implementation, the issue is assigned to the developer and the status is set to `Doing` (`Ready` is removed).
* Once all changes for the issue are fully ready in one (or more) merge requests, the status is set to `Review` (and `Doing` is removed) by the current assignee.
    * If possible (and useful), the MR is assigned to a reviewer for code review. If necessary, iterative changes are made until the code review is successful and can be merged.
    * A member of the search index core team merges the MRs as soon as the current deployment schedule allows.
    * After all MRs have been merged, the configuration for the development system is adjusted (if necessary - ping a TIB-member for this) and the changes are deployed (ideally automatically) to the development system and the issue is assigned to a reviewer for functional review. If necessary, iterative changes are made until the functional review is successful. The result of the review has to be documented on the issue.
* If necessary, configurations for the production system are adjusted (ping a TIB-member for this). The issue is now ready for installation on the production system. The status is set to `Deploy` (and `Review` is removed). The issue's assignee is removed and the issue's milestone is set to the currently pending milestone.
* A TIB member will perform the next production installation soon, if no issue blocks this (consider issues with label `blocks deployment`). After the installation, all issues with status `Deploy` are closed (and the label `Deploy` is removed). Depending on the implemented change, it may be necessary to wait for the next nightly import before the changes become visible.

### Workflow for external contributers

* Fork the project into your personal namespace (or group).
* Create a feature branch in your fork from master (don't work off master).
* Write tests, code and documentations that satisfy [coding conventions](#coding-conventions).
* When the feature is fully implemented (see [Definition of Done](#definition-of-done)), submit a merge request to the master branch in the original project. One of the core developers will then look at the MR, discuss any adjustments with you, and once everything is ok, merge the MR.

### Coding conventions

* Code Style: [Google Code Style](https://google.github.io/styleguide/)
* No issues in [sonarlint](https://www.sonarlint.org/).
* [sonarcloud](https://sonarcloud.io/) Quality Gate passed for the merge request.
    * If you are working in your fork, this may not work in your fork's pipeline. A search index core team member can copy your branch into the original search index repo to make this work once you have finished implementing it.
* Automated tests for new code should always be added.
* Language: everything (source code, comments, documentation, ...) in English.
* Commit messages guidelines
     * The commit subject must not contain more than 72 characters.
     * The commit subject and body must be separated by a blank line.
     * The issue or merge request should be added to the commit message.
     * Use issues and merge requests' full URLs instead of short references.

### Definition of Done

When can a task be marked as "finished"?

* All requirements of the feature implemented / all acceptance criteria fulfilled.
* Documentation is completely finished and understandable.
* Automated tests (e.g. unit tests) have been created, code coverage > 80%
* No open bugs (testing with [sonarlint](https://www.sonarlint.org/) / [sonarcloud](https://sonarcloud.io/))
* The code is finished and merged into the master branch.
* Concluding short comment in the issue: what has been done / what is the current status?

### Search Index Branching Strategy

* main (or master)
     * long living
     * stable branch (all merges and commits are "ready-for-production")
* feature- / topic-branches
     * branch from main / master
     * merge into main / master when ready (see [Definition of Done](#definition-of-done))
     * stability can be achieved by testing the feature-branch in the local Vagrant VM first and/or by using feature toggles.
     
**Note:** we do not support hotfixes. Bugs are fixed in the current main.
     
![Branching Strategy](doc/images/branching_strategy.png)

